#include <windows.h>
#include "init_D3D.h"
#include "decl_init_D3D.h"
#include "tutor.h"
#include "decl_vect_matr.h"
#include "mesh.h"
#include "decl_mesh.h"
#include "decl_timer.h"

#define LONG_FENETRE 300
#define LARG_FENETRE 300

_mesh_ *mtm[8];

LONGLONG *temps;

clavier et_module = {0, 0, 0, 0};
clavier et_module2 = {0, 0, 0, 0};

VOID Cleanup()
{
	if( obj_Direct3DDevice != NULL)
		obj_Direct3DDevice->Release();

	if( obj_Direct3D != NULL)
		obj_Direct3D->Release();

	if( obj_Direct3DDevice2 != NULL)
		obj_Direct3DDevice2->Release();

	if( obj_Direct3D2 != NULL)
		obj_Direct3D2->Release();

	unsigned int i;
	for (i = 0; i<8; i++) {
		if (mtm[i]->Materiaux)
		delete[] mtm[i]->Materiaux;

		if (mtm[i]->Textures) {
			for(unsigned int j=0; j<mtm[i]->nbr_de_mat; j++)
				if (mtm[i]->Textures[j])
					mtm[i]->Textures[j]->Release();
				delete[] mtm[i]->Textures;
		}

	if(mtm[i]->obj_mesh)
		mtm[i]->obj_mesh->Release();
	}
}

VOID Rendu(unsigned int param, LPDIRECT3DDEVICE9 *D3DD, _module_ *rp, _module_ *rp2, _mesh_ *mtm_modulea, _mesh_ *mtm_laby, _mesh_ *mtm_missile, _mesh_ *mtm_moduleb, clavier *etm)
{
	if (timer(25000, temps)) return;

	(*D3DD)->Clear( 0, NULL, param, D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );

	// dbut de la scne
	(*D3DD)->BeginScene();

	// fin de la scne
	(*D3DD)->EndScene();

	// affiche le back buffer  l'cran
	(*D3DD)->Present(NULL, NULL, NULL, NULL);

}

LRESULT CALLBACK MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	return DefWindowProc( hWnd, msg, wParam, lParam );
}

INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    // Enregistre la classe de la fentre
    WNDCLASSEX wc = {
		sizeof(WNDCLASSEX),
		CS_CLASSDC, MsgProc,
		0L, 0L,
		GetModuleHandle(NULL),
		NULL, NULL, NULL, NULL,
		"SuperBattle", NULL };

		RegisterClassEx( &wc );

		// Cration de la fentre d'application
		HWND hWnd = CreateWindow(
		"Superbattle", "Superbattle",
		WS_OVERLAPPEDWINDOW,
		100, 100, LONG_FENETRE, LARG_FENETRE * 2,
		GetDesktopWindow(),
		NULL, wc.hInstance, NULL );

		//Cration des fentres filles
		HWND hCtrl_1 = CreateWindow("EDIT", "", WS_CHILD|WS_VISIBLE, 0, 0, LONG_FENETRE, LARG_FENETRE, hWnd, NULL, hInst, NULL);

		HWND hCtrl_2 = CreateWindow("EDIT", "", WS_CHILD|WS_VISIBLE, 0, LARG_FENETRE + 1, LONG_FENETRE, LARG_FENETRE, hWnd, NULL, hInst, NULL);

		// Initialise Direct3D

		if(( SUCCEEDED( InitD3D(hCtrl_1, LONG_FENETRE, LARG_FENETRE, &obj_Direct3D, &obj_Direct3DDevice))
		&&
		SUCCEEDED( InitD3D(hCtrl_2, LONG_FENETRE, LARG_FENETRE, &obj_Direct3D2, &obj_Direct3DDevice2))
		) == E_FAIL)
			return -1;

		// vrifie prsence de l'horloge de prcision et initialise temps
		if (!(temps = horloge())) return -1;

		_module_ *module1 = new _module_;
		_module_ *module2 = new _module_;

		module1->position_cam.x = 0.0f;
		module1->position_cam.y = 0.0f;
		module1->position_cam.z = -70.0f;
		module1->monde = identite();
		module1->rot_cam = 0.0f;
		module1->coef_rotation_module = 0.0f;
		module1->coef_vitesse_module = 0.0f;
		module1->coef_cam = 0.0f;
		module1->module_rot = 0.0f;
		module1->coord_0.x = 0.0f;
		module1->coord_0.y = 0.0f;
		module1->coord_0.z = -50.0f;
		module1->rayon = 20;
		module1->collision = 0;
		module1->missile = NULL;

		module2->position_cam.x = 0.0f;
		module2->position_cam.y = 0.0f;
		module2->position_cam.z = -70.0f;
		module2->monde = identite();
		module2->rot_cam = 0.0f;
		module2->coef_rotation_module = 0.0f;
		module2->coef_vitesse_module = 0.0f;
		module2->coef_cam = 0.0f;
		module2->module_rot = 0.0f;
		module2->coord_0.x = 0.0f;
		module2->coord_0.y = 0.0f;
		module2->coord_0.z = 50.0f;
		module2->rayon = 20;
		module2->collision = 0;
		module2->missile = NULL;

		// cration des diffrents mesh

		char chemin[4][10] = {"module.x", "module2.x", "laby.x", "missile.x"};

		unsigned int i, k = 0;

		for(i = 0; i<8; i+=2) {
			mtm[i] = charge_mesh(chemin[k], &obj_Direct3DDevice);
			if(mtm[i]==NULL)
				return -1;

			mtm[i+1] = charge_mesh(chemin[k], &obj_Direct3DDevice2);
			if(mtm[i+1]==NULL)
				return -1;
			k++;
		}


		ShowWindow(hWnd, SW_SHOWDEFAULT);
		UpdateWindow(hWnd);

		MSG msg;
		ZeroMemory( &msg, sizeof(msg) );

		while( msg.message!=WM_QUIT )
		{
			if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
			{
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
			else {
				Rendu(D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, &obj_Direct3DDevice, module1, module2, mtm[0], mtm[4], mtm[6], mtm[2], &et_module);
				Rendu(D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, &obj_Direct3DDevice2, module2, module1, mtm[3], mtm[5], mtm[7], mtm[1], &et_module2);
			}
		}
   
		UnregisterClass("Superbattle", wc.hInstance);
    
	return 0;
}
